;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Screen Slicer
;
;  PRINT USR SLIC;[Speed][CODE "CHR X"]
;
;================================
@StackBC=0BF5		;Move results to BC
@Class6=0D92		;Expression evaluator, if value>255 then error B
@DFile=400C		;Start of DFile
@LastK=4025		;Key press value
@Seed=4032		;Random Number Seed
@Fill=407B		;Spare2, Fill value  IY+123
@Speed=407C		;Spare3, Speed value IY+124
@Buff1=403C		;Column done buffer

@Slicer
	LD BC,001F	;Clear PRBuff area
	LD HL,Buff1	;LDIR setup
	LD (HL),B
	LD D,H
	LD E,L
	INC DE
	LDIR
	RST 20		;Get next character
	LD A,75		;Check for parameters
	INC A
	CP (HL)
	LD A,B		;B=0 A=0, default values
	JR Z NoPars	;Jump if no parameters
	CALL Class6	;Evaluate [Speed] expression 
	RST 20 		;Get next character
	CALL Class6	;Evaluate [CODE "Chr X"] expression
	CALL StackBC	;Move results to BC, B=Fill, A=C=Speed
@NoPars
	LD (IY+123),B	;Store Fill
	LD (Speed),A	;Store Speed
	JR Loop
;================================
; Return random number between 0 and 23
;
;   On return A=Random number value
;
;================================
@RNDNum
	EXX		;Swap reg
	LD DE,(Seed)
	LD H,E 
	LD L,FD 
	LD A,D 
	OR A 
	LD B,00 
	SBC HL,DE 
	SBC A,B 
	SBC HL,DE 
	SBC A,B 
	LD E,A 
	LD D,B 
	SBC HL,DE 
	JR NC +1
	INC HL 
	LD (Seed),HL
	LD A,L
	AND 1F		;Range 0 to 31
	LD L,A
	SUB 18		;Subtract 24
	JR NC RNDNum+1	;If NC then Loop, L>23
	LD A,L		;Range 0 to 23
	EXX		;Restore reg
	JR RndX+2	;RET
;================================
@Loop
	XOR A
	LD C,18
	LD B,C
	LD HL,Buff1
@DoneTest
	ADD A,(HL)
	INC HL
	DJNZ DoneTest
	CP C
	JR NZ RndX
	XOR A
	JR Left-2	;JP SetFlag
@RndX
	JR RNDNum	;"CALL RNDNum", A=Ycoord=0 to 23
	LD C,A		;C=Save Row to C
	LD HL,Buff1
	ADD HL,BC
	BIT 0,(HL)
	JR NZ RndX	;Already done so try again
	INC (HL)	;Mark as done
	LD A,C		;Restore Row to A
	LD HL,(DFile)	;Get DFile
	INC HL
	LD DE,0021	;Bytes/row
	AND A		;Test for 0
	JR Z Bit0	;Jump if 0
	LD B,A		;B=Row count
@AddY
	ADD HL,DE	;Add row offset
	DJNZ AddY
@Bit0
	LD B,20		;Loop counter
	BIT 0,(IY+50)	;Get random Left or right slice by testing Seed
	JR Z Left
@Right
	LD E,1F		;Offset to right margin
	ADD HL,DE	;HL=Right margin
	LD D,H		;LDDR setup
	LD E,L
	DEC DE
	EX DE,HL
@RiteLup
	PUSH BC		;PUSH counter
	PUSH HL		;PUSH source
	PUSH DE		;PUSH destination
	LD BC,001F	;Byte count
	LDDR		;Shift right
	LD A,(Fill)	;Get fill chr.
	LD (DE),A	;Print fill chr.
	POP DE		;POP destination
	POP HL		;POP source
;Check for keypress
	LD A,(LastK)	;Get keyboard status
	CP FF		;Key pressed?
	JR NZ Wait	;Jump if keypress
	LD B,(IY+124)	;Speed hi byte
	INC C		;Speed lo byte
@Delay1
	LD A,B
	OR C
	DEC BC
	JR NZ Delay1
	POP BC		;POP counter
	DJNZ RiteLup	;Loop until counter B=0
	JR Loop
;================================
	JR SetFlag	;Double jump needed
@Left
	EX DE,HL	;Setup for LDIR
	LD H,D
	LD L,E
	INC HL
	LD B,20		;Loop counter
@LeftLup
	PUSH BC		;PUSH counter
	PUSH HL		;PUSH source
	PUSH DE		;PUSH destination
	LD BC,001F	;Byte count
	LDIR		;Shift left
	LD A,(Fill)	;Get fill chr.
	LD (DE),A	;Print fill chr.
	POP DE		;POP destination
	POP HL		;POP source
;Check for keypress
	LD A,(LastK)	;Get keyboard status
	CP FF		;Key pressed?
	JR NZ Wait	;Jump if keypress
	LD B,(IY+124)	;Speed hi byte
	INC C		;Speed lo byte
@Delay2
	LD A,B
	OR C
	DEC BC
	JR NZ Delay2
	POP BC		;POP counter
	DJNZ LeftLup	;Loop until counter B=0
	JR Left-4	;JP Loop
@Wait
	LD A,(LastK)	;Get keyboard status
	CP FF		;Key pressed?
	JR NZ Wait	;Jump if keypress
	POP AF		;Clear stack
	LD A,01		;Set keypress flag to 1
@SetFlag
	LD (Buff1),A	;Set keypress flag to 0 or 1
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF

